"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.computeConstantProductPoolAddress = void 0;
const abi_1 = require("@ethersproject/abi");
const address_1 = require("@ethersproject/address");
const solidity_1 = require("@ethersproject/solidity");
const ConstantProductPool_json_1 = __importDefault(require("@sushiswap/trident/artifacts/contracts/pool/constant-product/ConstantProductPool.sol/ConstantProductPool.json"));
const computeConstantProductPoolAddress = ({ factoryAddress, tokenA, tokenB, fee, twap, }) => {
    // does safety checks
    const [token0, token1] = tokenA.sortsBefore(tokenB) ? [tokenA, tokenB] : [tokenB, tokenA];
    const deployData = abi_1.defaultAbiCoder.encode(['address', 'address', 'uint256', 'bool'], [token0.address, token1.address, fee, twap]);
    const CONSTANT_PRODUCT_POOL_INIT_CODE_HASH = (0, solidity_1.keccak256)(['bytes'], [ConstantProductPool_json_1.default.bytecode]);
    // Compute pool address
    return (0, address_1.getCreate2Address)(factoryAddress, (0, solidity_1.keccak256)(['bytes'], [deployData]), CONSTANT_PRODUCT_POOL_INIT_CODE_HASH);
};
exports.computeConstantProductPoolAddress = computeConstantProductPoolAddress;
