import { Amount, Token } from 'soulswap-currency';
import { JSBI } from 'soulswap-math';
import { Fee } from '../Fee';
export declare abstract class Pool {
    abstract readonly liquidityToken: Token;
    abstract readonly swapGasCost: JSBI;
    abstract readonly minLiquidity: JSBI;
    abstract get chainId(): number;
    abstract get fee(): Fee;
    abstract get assets(): Token[];
    abstract get reserves(): Amount<Token>[];
    abstract getLiquidityMinted(totalSupply: Amount<Token>, tokenAmountA: Amount<Token>, tokenAmountB: Amount<Token>): Amount<Token>;
    abstract getLiquidityValue(token: Token, totalSupply: Amount<Token>, liquidity: Amount<Token>): Amount<Token>;
    abstract involvesToken(token: Token): boolean;
}
//# sourceMappingURL=Pool.d.ts.map