"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.computeStablePoolAddress = void 0;
const abi_1 = require("@ethersproject/abi");
const address_1 = require("@ethersproject/address");
const solidity_1 = require("@ethersproject/solidity");
const StablePool_json_1 = __importDefault(require("@sushiswap/trident/artifacts/contracts/pool/stable/StablePool.sol/StablePool.json"));
const computeStablePoolAddress = ({ factoryAddress, tokenA, tokenB, fee, }) => {
    // does safety checks
    const [token0, token1] = tokenA.sortsBefore(tokenB) ? [tokenA, tokenB] : [tokenB, tokenA];
    const deployData = abi_1.defaultAbiCoder.encode(['address', 'address', 'uint256'], [token0.address, token1.address, fee]);
    const STABLE_POOL_INIT_CODE_HASH = (0, solidity_1.keccak256)(['bytes'], [StablePool_json_1.default.bytecode]);
    // Compute pool address
    return (0, address_1.getCreate2Address)(factoryAddress, (0, solidity_1.keccak256)(['bytes'], [deployData]), STABLE_POOL_INIT_CODE_HASH);
};
exports.computeStablePoolAddress = computeStablePoolAddress;
