import { Amount, Price, Type as Currency } from 'soulswap-currency';
import { Percent } from 'soulswap-math';
/**
 * Returns the percent difference between the mid price and the execution price, i.e. price impact.
 * @param midPrice mid price before the trade
 * @param inputAmount the input amount of the trade
 * @param outputAmount the output amount of the trade
 */
export declare function computePriceImpact<TBase extends Currency, TQuote extends Currency>(midPrice: Price<TBase, TQuote>, inputAmount: Amount<TBase>, outputAmount: Amount<TQuote>): Percent;
//# sourceMappingURL=computePriceImpact.d.ts.map