"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.convertPoolOrPairtoRPool = void 0;
const bignumber_1 = require("@ethersproject/bignumber");
const soulswap_tines_1 = require("soulswap-tines");
const ConstantProductPool_1 = require("../ConstantProductPool");
const Fee_1 = require("../Fee");
const Pair_1 = require("../Pair");
const StablePool_1 = require("../StablePool");
function convertPoolOrPairtoRPool(pool) {
    if (pool instanceof Pair_1.Pair) {
        return new soulswap_tines_1.ConstantProductRPool(pool.liquidityToken.address, pool.token0, pool.token1, Fee_1.Fee.DEFAULT / 10000, bignumber_1.BigNumber.from(pool.reserve0.quotient.toString()), bignumber_1.BigNumber.from(pool.reserve1.quotient.toString()));
    }
    else if (pool instanceof ConstantProductPool_1.ConstantProductPool) {
        return new soulswap_tines_1.ConstantProductRPool(pool.liquidityToken.address, pool.assets[0].wrapped, pool.assets[1].wrapped, pool.fee / 10000, bignumber_1.BigNumber.from(pool.reserves[0].quotient.toString()), bignumber_1.BigNumber.from(pool.reserves[1].quotient.toString()));
    }
    else if (pool instanceof StablePool_1.StablePool) {
        return new soulswap_tines_1.StableSwapRPool(pool.liquidityToken.address, pool.token0, pool.token1, pool.fee / 10000, bignumber_1.BigNumber.from(pool.reserve0.quotient.toString()), bignumber_1.BigNumber.from(pool.reserve1.quotient.toString()), pool.token0.decimals, pool.token1.decimals, 
        // JSBI.toNumber(pool.decimals0),
        // JSBI.toNumber(pool.decimals1),
        { elastic: bignumber_1.BigNumber.from(pool.total0.elastic.toString()), base: bignumber_1.BigNumber.from(pool.total0.base.toString()) }, { elastic: bignumber_1.BigNumber.from(pool.total1.elastic.toString()), base: bignumber_1.BigNumber.from(pool.total1.base.toString()) }
        // { elastic: BigNumber.from(1), base: BigNumber.from(1) },
        // { elastic: BigNumber.from(1), base: BigNumber.from(1) }
        );
    }
    else {
        throw new Error('Unsupported type of pool !!!');
    }
}
exports.convertPoolOrPairtoRPool = convertPoolOrPairtoRPool;
