"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TridentRouter = void 0;
const tiny_invariant_1 = __importDefault(require("tiny-invariant"));
/**
 * Represents the Trident Router, and has static methods for helping execute trades.
 */
class TridentRouter {
    /**
     * Cannot be constructed.
     */
    constructor() { }
    /**
     * Produces the on-chain method name to call and the hex encoded parameters to pass as arguments for a given trade.
     * @param trade to produce call parameters for
     * @param options options for the call parameters
     */
    static swapCallParameters(trade, options) {
        const etherIn = trade.inputAmount.currency.isNative;
        const etherOut = trade.outputAmount.currency.isNative;
        // the router does not support both ether in and out
        (0, tiny_invariant_1.default)(!(etherIn && etherOut), 'ETHER_IN_OUT');
        let methodName;
        let args;
        let value;
        if (trade.isSinglePool()) {
            //
        }
        else if (trade.isSingle()) {
            //
        }
        else if (trade.isComplex()) {
            //
        }
        return {
            methodName: '',
            args: [],
            value: '0x0',
        };
    }
}
exports.TridentRouter = TridentRouter;
